import { Injectable, ɵɵdefineInjectable, Component, forwardRef, Injector, ElementRef, Input, ViewChild, NgModule } from '@angular/core';
import { NgControl, NG_VALUE_ACCESSOR, FormsModule } from '@angular/forms';
import { noop } from 'rxjs';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ng-bootstrap-fileupload-angular.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgBootstrapFileuploadAngularService = /** @class */ (function () {
    function NgBootstrapFileuploadAngularService() {
    }
    NgBootstrapFileuploadAngularService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    NgBootstrapFileuploadAngularService.ctorParameters = function () { return []; };
    /** @nocollapse */ NgBootstrapFileuploadAngularService.ngInjectableDef = ɵɵdefineInjectable({ factory: function NgBootstrapFileuploadAngularService_Factory() { return new NgBootstrapFileuploadAngularService(); }, token: NgBootstrapFileuploadAngularService, providedIn: "root" });
    return NgBootstrapFileuploadAngularService;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ng-bootstrap-fileupload-angular.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgBootstrapFileuploadAngularComponent = /** @class */ (function () {
    function NgBootstrapFileuploadAngularComponent(inj, host) {
        this.inj = inj;
        this.host = host;
        this.selectedFile = null;
        this.previewUrl = null;
        this.showPreview = true;
        this.onTouched = noop;
        this.onChange = noop;
    }
    /**
     * @return {?}
     */
    NgBootstrapFileuploadAngularComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        // tslint:disable-next-line: deprecation
        this.ngControl = this.inj.get(NgControl);
        this.defaultUrl = this.previewUrl;
    };
    /**
     * @param {?} newModel
     * @return {?}
     */
    NgBootstrapFileuploadAngularComponent.prototype.writeValue = /**
     * @param {?} newModel
     * @return {?}
     */
    function (newModel) {
        this.host.nativeElement.value = '';
        this.selectedFile = null;
    };
    /**
     * @param {?} $event
     * @return {?}
     */
    NgBootstrapFileuploadAngularComponent.prototype.onFileSelected = /**
     * @param {?} $event
     * @return {?}
     */
    function ($event) {
        console.log('file selected change');
        this.selectedFile = (/** @type {?} */ ($event.target.files[0]));
        if (this.selectedFile) {
            this.onChange(this.selectedFile);
            this.fileName = this.selectedFile.name;
            this.preview();
        }
    };
    /**
     * @return {?}
     */
    NgBootstrapFileuploadAngularComponent.prototype.clear = /**
     * @return {?}
     */
    function () {
        this.selectedFile = null;
        this.fileName = '';
        this.previewUrl = this.defaultUrl;
        this.file.nativeElement.value = null;
        this.onChange(this.selectedFile);
    };
    /**
     * @return {?}
     */
    NgBootstrapFileuploadAngularComponent.prototype.preview = /**
     * @return {?}
     */
    function () {
        var _this = this;
        // Show preview
        /** @type {?} */
        var mimeType = this.selectedFile.type;
        if (mimeType.match(/image\/*/) == null) {
            return;
        }
        /** @type {?} */
        var reader = new FileReader();
        reader.readAsDataURL(this.selectedFile);
        reader.onload = (/**
         * @param {?} _event
         * @return {?}
         */
        function (_event) {
            _this.previewUrl = reader.result;
        });
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    NgBootstrapFileuploadAngularComponent.prototype.registerOnChange = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) {
        this.onChange = fn;
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    NgBootstrapFileuploadAngularComponent.prototype.registerOnTouched = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) {
        this.onTouched = fn;
    };
    /**
     * @param {?} $event
     * @return {?}
     */
    NgBootstrapFileuploadAngularComponent.prototype.inputBlur = /**
     * @param {?} $event
     * @return {?}
     */
    function ($event) {
        this.onTouched();
    };
    NgBootstrapFileuploadAngularComponent.decorators = [
        { type: Component, args: [{
                    selector: "ng-bootstrap-fileupload-angular",
                    template: "<img *ngIf=\"showPreview && previewUrl\" [src]=\"previewUrl ? previewUrl : ''\" class=\"img-fluid\" alt=\"Image\" (click)=\"file.click()\">\r\n\r\n<input type=\"file\" class=\"invisible\" placeholder=\"Descripci\u00F3n\" #file (change)=\"onFileSelected($event)\" />\r\n\r\n<div class=\"input-group mb-2\">\r\n  <div class=\"input-group-prepend\" (click)=\"clear()\">\r\n    <div class=\"input-group-text\"><i class=\"fa fa-times-circle-o\" aria-hidden=\"true\"></i></div>\r\n  </div>\r\n  <input type=\"text\" [value]=\"fileName ? fileName : ''\" class=\"form-control\" placeholder=\"Seleccione\"\r\n    (click)=\"file.click()\">\r\n  <div class=\"input-group-append\" (click)=\"file.click()\">\r\n    <div class=\"input-group-text\"><i class=\"fa fa-folder-open-o\" aria-hidden=\"true\"></i></div>\r\n  </div>\r\n</div>",
                    providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef((/**
                             * @return {?}
                             */
                            function () { return NgBootstrapFileuploadAngularComponent; })),
                            multi: true
                        }
                    ]
                }] }
    ];
    /** @nocollapse */
    NgBootstrapFileuploadAngularComponent.ctorParameters = function () { return [
        { type: Injector },
        { type: ElementRef }
    ]; };
    NgBootstrapFileuploadAngularComponent.propDecorators = {
        previewUrl: [{ type: Input }],
        showPreview: [{ type: Input }],
        file: [{ type: ViewChild, args: ['file', null,] }]
    };
    return NgBootstrapFileuploadAngularComponent;
}());
if (false) {
    /** @type {?} */
    NgBootstrapFileuploadAngularComponent.prototype.selectedFile;
    /** @type {?} */
    NgBootstrapFileuploadAngularComponent.prototype.defaultUrl;
    /** @type {?} */
    NgBootstrapFileuploadAngularComponent.prototype.fileName;
    /** @type {?} */
    NgBootstrapFileuploadAngularComponent.prototype.previewUrl;
    /** @type {?} */
    NgBootstrapFileuploadAngularComponent.prototype.showPreview;
    /** @type {?} */
    NgBootstrapFileuploadAngularComponent.prototype.file;
    /**
     * @type {?}
     * @private
     */
    NgBootstrapFileuploadAngularComponent.prototype.onTouched;
    /**
     * @type {?}
     * @private
     */
    NgBootstrapFileuploadAngularComponent.prototype.onChange;
    /** @type {?} */
    NgBootstrapFileuploadAngularComponent.prototype.ngControl;
    /**
     * @type {?}
     * @private
     */
    NgBootstrapFileuploadAngularComponent.prototype.inj;
    /**
     * @type {?}
     * @private
     */
    NgBootstrapFileuploadAngularComponent.prototype.host;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ng-bootstrap-fileupload-angular.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgBootstrapFileuploadAngularModule = /** @class */ (function () {
    function NgBootstrapFileuploadAngularModule() {
    }
    NgBootstrapFileuploadAngularModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [NgBootstrapFileuploadAngularComponent],
                    imports: [
                        CommonModule,
                        FormsModule
                    ],
                    exports: [NgBootstrapFileuploadAngularComponent]
                },] }
    ];
    return NgBootstrapFileuploadAngularModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: ng-bootstrap-fileupload-angular.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgBootstrapFileuploadAngularComponent, NgBootstrapFileuploadAngularModule, NgBootstrapFileuploadAngularService };
//# sourceMappingURL=ng-bootstrap-fileupload-angular.js.map
